=== debian/changelog ===
mir (2.20.2-2ubuntu4) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:13:13 +0200

mir (2.20.2-2ubuntu3) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:02:48 +0200

mir (2.20.2-2ubuntu2) questing; urgency=medium

  * debian/rules: 
    - update the disable LTO hack to not apply to a specific ld version
      we got an update and the build issue is still there (lp: #2099790)

 -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 08 Jul 2025 15:11:14 +0200

mir (2.20.2-2ubuntu1) questing; urgency=medium

  * debian/patches/0001-glib-285.patch:
    - cherry-pick an upstream changed to fix the tests with glib 2.85
      (lp: #2116068)

 -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 08 Jul 2025 10:45:39 +0200

mir (2.20.2-2) unstable; urgency=medium

  * debian/patches:
    + Trivially rebase patches 2003 and 2005.
    + Add 1004_fix-autopkgtest.patch. In tests/acceptance-tests/wayland/
      CMakeLists.txt: Reference expected_wlcs_failures.list with full-path
      relative to builddir, so that autopkgtest's cmake call succeeds in
      finding the file.
  * debian/tests/wlcs:
    + Typo fix in comment.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 22 Apr 2025 11:41:40 +0200

mir (2.20.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/mir-wlcs-integration.install:
    + Add a new file to mir-wlcs-integration.
  * debian/source/lintian-overrides:
    + Adjust file-line in very-long-line-length-in-source-file override.
  * debian/man:
    + Drop mir-shell.1. No such script anymore in Mir.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 17 Apr 2025 15:44:03 +0200

mir (2.20.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 1004_fix-lomiri-crash-on-app-close.patch. Patch rejected upstream.
      Different solution provided in qtmir (>= 0.8.0~git20250319.5ab362a-1).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 28 Mar 2025 10:21:00 +0100
