=== debian/tests/control ===
Tests: wlcs
Restrictions: allow-stderr, skippable
Depends: wlcs, pkg-config, dpkg, mir-wlcs-integration, cmake, build-essential
